(function () {
    "use strict";

    angular.module('core').controller('reportFinanceiroCR000008Controller', controller);
    controller.$inject = ['$scope', '$timeout', '$q', '$stateParams', '$alert', 'faturaReceberService', 'lookupService'];

    function controller($scope, $timeout, $q, $stateParams, $alert, faturaReceberService, lookupService) {
        $scope.initializeLayout('Liquidação Títulos a Receber');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            carregandoMais: false,
            salvando: false,
            vazio: false,
            count: 0,
            filtro: { ativo: false, args: null },
            tipoLiquidacao: ['Liquidação', 'Abatimento', 'Cancelamento', 'Multa', 'Juros', 'Custas', 'Despesas'],
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.clearFilter();
            $scope.refresh();
        };

        $scope.getAll = function () {
            $scope.state.filtro.args.skip = 0;
            $scope.state.carregando = true;
            $scope.state.vazio = false;

            faturaReceberService
                .getAllLiquidacaoTituloReceber($scope.state.filtro.args)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                    } else {
                        angular.copy(angular.fromJson(response.Data), $scope.state.data);
                    }
                    $scope.state.carregando = false;
                    $scope.state.vazio = ($scope.state.data == 0);
                },
                function (_error) {
                    $scope.state.carregando = false;
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                }
                );
        };

        $scope.refresh = function () {
            $scope.state.filtro.ativo = false;
            $scope.getAll();
        };

        $scope.clearFilter = function () {
            $scope.state.filtro.args = {
                chaves: '',
                filtro: null,
                filtroDe: null,
                filtroAte: null,
                sortExpression: '',
                skip: 0,
                take: 100
            };
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();